diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index b9979de3a..a9dd6427b 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -81,7 +81,7 @@ public class PlayerServer extends Player implements ContainerListener {
 	public void moveEntityWithHeading(float moveStrafing, float moveForward)
     {
         super.moveEntityWithHeading(moveStrafing, moveForward);
-        if (noPhysics)
+        if (hasNoPhysics())
         {
             yd = 0.0D;
             onGround = true;
@@ -108,7 +108,7 @@ public class PlayerServer extends Player implements ContainerListener {
         inventoryMenu.addSlotListener(this);
         if (!gamemode.hasPlayerFlight())
         {
-            noPhysics = false;
+            setNoPhysics(false);
         }
 
         fireImmune = gamemode.hasFireImmunity();
@@ -117,7 +117,7 @@ public class PlayerServer extends Player implements ContainerListener {
     @Override
 	public @Nullable AABBdc getCollisionAABB()
     {
-        if (noPhysics)
+        if (hasNoPhysics())
         {
             return null;
         }
@@ -183,6 +183,17 @@ public class PlayerServer extends Player implements ContainerListener {
         playerController.tick();
         ticksOfInvuln--;
         containerMenu.broadcastChanges();
+
+        ItemStack heldItem = inventory.getHeldItemStack();
+        if (!ItemStack.areItemStacksEqual(heldItem, lastHeldItem))
+        {
+            if (playerNetServerHandler != null)
+            {
+                playerNetServerHandler.sendPacket(new PacketContainerSetSlot(-1, -1, heldItem));
+            }
+            lastHeldItem = heldItem == null ? null : heldItem.copy();
+        }
+
         for (int i = 0; i < 5; i++)
         {
             ItemStack itemstack = getEquipmentInSlot(i);
@@ -288,7 +299,7 @@ public class PlayerServer extends Player implements ContainerListener {
             }
         }
 
-        if (inPortal && !noPhysics)
+        if (inPortal && !hasNoPhysics())
         {
             Dimension targetDim = ((BlockLogicPortal) Blocks.blocksList[portalID].getLogic()).targetDimension;
             boolean netherAllowed = mcServer.propertyManager.getBooleanProperty("allow-nether", true);
@@ -677,6 +688,14 @@ public class PlayerServer extends Player implements ContainerListener {
         yRot = f3;
     }
 
+    @Override
+	public void revokeAchievement(Stat stat) {
+        if (stat == null) {
+            return;
+        }
+        playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, -1));
+    }
+
     @Override
 	public void addStat(@Nullable Stat stat, int i)
     {
@@ -686,12 +705,21 @@ public class PlayerServer extends Player implements ContainerListener {
         }
         if (!stat.clientside)
         {
-            for (; i > 100; i -= 100) { // send value change in groups of 100
-                playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, 100));
-            }
-
             if (i > 0) {
-                playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, i));
+                for (; i > 100; i -= 100) {
+                    playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, 100));
+                }
+                if (i > 0) {
+                    playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, i));
+                }
+            } else if (i < 0) {
+                int remaining = -i;
+                for (; remaining > 100; remaining -= 100) {
+                    playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, -100));
+                }
+                if (remaining > 0) {
+                    playerNetServerHandler.sendPacket(new PacketStatistic(stat.statId, -remaining));
+                }
             }
         }
     }
@@ -788,6 +816,7 @@ public class PlayerServer extends Player implements ContainerListener {
     private ItemStack[] playerInventory = {
             null, null, null, null, null
     };
+    private ItemStack lastHeldItem;
     private int currentWindowId;
     public boolean isChangingQuantityOnly;
 }
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index b4b3edf6c..2bb059989 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -545,16 +545,27 @@ public class PacketHandlerServer extends PacketHandler
     @Override
     public void handleUpdatePlayerState(@NotNull PacketUpdatePlayerState packetUpdatePlayerState) {
         if (!this.playerEntity.isAlive()) return;
-        if (packetUpdatePlayerState.state == PacketUpdatePlayerState.STATE_SNEAK) {
-            this.playerEntity.setSneaking(true);
-            if (this.playerEntity.vehicle != null) {
-                this.playerEntity.vehicle.ejectRider();
+        switch (packetUpdatePlayerState.state) {
+            case PacketUpdatePlayerState.STATE_SNEAK -> {
+                this.playerEntity.setSneaking(true);
+                if (this.playerEntity.vehicle != null) {
+                    this.playerEntity.vehicle.ejectRider();
+                }
+            }
+            case PacketUpdatePlayerState.STATE_UN_SNEAK -> this.playerEntity.setSneaking(false);
+            case PacketUpdatePlayerState.STATE_LEAVE_BED -> {
+                this.playerEntity.wakeUpPlayer(false, true);
+                this.hasMoved = false;
+            }
+            case PacketUpdatePlayerState.STATE_NO_CLIP -> {
+                this.playerEntity.setNoclip(true);
+                if (!this.playerEntity.gamemode.hasPlayerFlight()) {
+                    this.playerEntity.setNoclip(false);
+                }
+            }
+            case PacketUpdatePlayerState.STATE_DO_CLIP -> {
+                this.playerEntity.setNoclip(false);
             }
-        } else if (packetUpdatePlayerState.state == PacketUpdatePlayerState.STATE_UN_SNEAK) {
-            this.playerEntity.setSneaking(false);
-        } else if (packetUpdatePlayerState.state == PacketUpdatePlayerState.STATE_LEAVE_BED) {
-            this.playerEntity.wakeUpPlayer(false, true);
-            this.hasMoved = false;
         }
     }
 
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index ca95a3382..4d7899c9d 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -485,7 +485,8 @@ class WorkbenchGenerator {
             .addInput(Items.SULFUR)
             .addInput(Items.CLAY)
             .addInput(new ItemStack(Items.DYE, 1, DyeColor.WHITE.itemMeta))
-            .create("dirt", new ItemStack(Blocks.DIRT, 2));
+            .addInput(Items.AMMO_PEBBLE)
+            .create("dirt", new ItemStack(Blocks.DIRT, 4));
     }
 
 
